; =============== S U B	R O U T	I N E =======================================

InputCheck:				; CODE XREF: RAM:4053 p
;		ld		a, (g_Flags)	; 4 1 -	0 - joy, 1 - KeyboardUserInput
;		bit		4, a 			;z80_key InputCheck:	
;		jp		nz, CheckKeyboard

		jp		CheckKeyboard
;dummy no key
;		xor 		a

;		ld		a, 14		; Joy Port A
;		out		(PSG_RegisterWrite), a
;		in		a, (PSG_ValueRead) ; b0: Up b1:Down b2:Left b3:Right b4:A b5:B
;		cpl
;		and		3Fh ; '?'


_WriteKey:				; CODE XREF: InputCheck+42 j
		ld		hl, KeyCurrent	; b0: Up b1:Down b2:Left b3:Right b4:A b5:B
		ld		c, (hl)
		ld		(hl), a
		dec		hl
		ld		(hl), c 		; prev keys
		ret
; ---------------------------------------------------------------------------

CheckSndOnOff:
;                   D7  D6  D5  D4  D3  D2  D1  D0
;                 |---|---|---|---|---|---|---|---|
;KB02 EQU  04H ;     В   Ж   У   Т   С   Р   Я   П

	ld 	a,(0f804h)
	and	8
	jp	z,.no_snd_0
.snd0:
	ld 	a,(0f804h)
	and	8
	jp	nz,.snd0

	ld	a,(no_sound_flag)
	xor	0FFh
	ld	(no_sound_flag),a

	di
	call 	update_snd_picture
	ei

.no_snd_0:
	ret

CheckKeyboard:				; CODE XREF: InputCheck+5 j


; b0: Up b1:Down b2:Left b3:Right b4:A b5:B

;KB06 EQU  40H ; ПРОБЕЛ ТАБ  ВШ  ВЗ  ИЗ СТП СТР  ВК
;KB08 EQU 101H ;     7   6   5   4   3   2   1   0
;KB09 EQU 102H ;         .                   9   8

;   8
; 4 5 6
;space

; 4  - b2
; 5  - b1
; 6  - b3
; 8  - b0
;spc - b4


	mdebug_check_key


	ld	c,0
	ld 	a,(0f840h)
	and 	1<<7
	jp 	z,ck_nospc
	ld 	c,1<<4

ck_nospc:
	ld 	a,(0f902h)
	and	1
	jp	z,ck_noUp
	ld	a,c
;	or	1<<0
	or	1<<4 		;up act as a 
	ld	c,a
ck_noUp:
	ld 	a,(0f901h)
	ld 	b,a

	and 	10h 		;left b2
	jp	z,ck_noLeft
	ld	a,c
	or	1<<2
	ld 	c,a
ck_noLeft:

	ld	a,b
	and 	20h 		;down b1
	jp	z,ck_noDown
	ld	a,c
	or	1<<1
	ld 	c,a
ck_noDown:
	ld	a,b
	and 	40h 		;right b3
	jp	z,ck_noRight
	ld	a,c
	or	1<<3
	ld 	c,a

ck_noRight:
	ld 	a,c
	jp	_WriteKey

;		ld		bc, 57AAh
;		out		(c), b 		;z80_key
;		out		(c), b 		;z80_key
;		in		a, (PPI_KBD_row)
;		cpl
;		rrca
;		and		100000b
;		ld		e, a
;		inc		b
;		out		(c), b 		;z80_key
;		out		(c), b 		;z80_key
;		in		a, (PPI_KBD_row)
;		cpl
;		rrca
;		rrca
;		ld		b, a
;		and		4
;		or		e
;		ld		c, a
;		ld		a, b
;		rrca
;		rrca
;		ld		b, a
;		and		18h
;		or		c
;		ld		c, a
;		ld		a, b
;		rrca
;		and		3
;		or		c

;dummy no key
;		xor 		a

;		jp		_WriteKey
; End of function InputCheck


; =============== S U B	R O U T	I N E =======================================

; Digits ROW

CheckGameStartKeys:			; CODE XREF: RAM:L4142 p
;KB08 EQU 101H ;     7   6   5   4   3   2   1   0
		ld 	a,(0f810h)

		and 	00011000b
		ret 	z
		ld	b,10h
		cp 	1000b 		;3
		jp	z,cgsk1
		ld 	b,30h 		;4
		cp 	10000b
		ret 	nz
cgsk1:
		ld 	a,b
		ld	(g_Flags), a	
		xor	a
		ld	(_PlayerCounter_), a 
		ld	a, 8
		ld	(MainLoopStepCounter), a
		pop	hl 	;?!!!!!!!!!
		ret

;		ld		a, 50h ; 'P'
;		out		(PPI_KBD_aa), a
;		out		(PPI_KBD_aa), a
;		in		a, (PPI_KBD_row)
;		cpl
;		and		11110b
;		rra
;		dec		a
;		cp		8
;		ret		nc
;		ld		hl, GameCountrolModeTable
;		call	add_a_hl
;		ld		a, (hl)
;		cp		0FFh
;		ret		z
;		ld		(g_Flags), a	; 0 1
;								; 1 2
;								; 2 4
;								; 3 8
;								; 4 1 -	0 - joy, 1 - KeyboardUserInput
;								; 5 2 -	0 one player,1 - 2 player
;								; 6 4 -	Game Flag (no demo)?
;								; 7 8 -	Activ Player?
;		xor		a
;		ld		(_PlayerCounter_), a ; 0 1
;									; 1 2
;									; 2 4
;									; 3 8
;									; 4 1
;									; 5 2 -	One/Two	player
;									; 6 4
;									; 7 8
;		ld		a, 8
;		ld		(MainLoopStepCounter), a
;;
;		call	_Joystick_Select12 ; Select Active joystick 1/2
;		pop		hl
;		ret
; End of function CheckGameStartKeys

;GameCountrolModeTable:		db	0, 20h,	0FFh, 10h, 0FFh,0FFh, 0FFh, 30h
; ---------------------------------------------------------------------------

; =============== S U B	R O U T	I N E =======================================

; Select Active	joystick 1/2

_Joystick_Select12:			; CODE XREF: CheckGameStartKeys+26 p
;					; RAM:433B p ...
;		ld		a, 15
;		out		(PSG_RegisterWrite), a
;		ld		a, 8Fh ; ''
;		ld		hl, g_Flags	; 0 1
;							; 1 2
;							; 2 4
;							; 3 8
;							; 4 1 -	0 - joy, 1 - KeyboardUserInput
;							; 5 2 -	0 one player,1 - 2 player
;							; 6 4 -	Game Flag (no demo)?
;							; 7 8 -	Activ Player?
;		bit		7, (hl)		;z80_joy _Joystick_Select12:	
;		jp		z, L4623
;		set		6, a		;z80_joy 1 - Select Joystick 2
;
;L4623:					; CODE XREF: _Joystick_Select12+B j
;		out		(PSG_ValueWrite), a
		ret
; End of function _Joystick_Select12


