

        macro xrow _len_
             dup     _len_
                ld      a,(de)
                cp      (hl)
                ;ld      a,034h
                ;ld      (hl),a
                jp      z,$+6
                call    show_char_store
                inc     hl
                inc     de
              edup
        endm

        macro update_pnt_0 cnt
                xrow     cnt*2-1
        endm

        macro update_pnt_l cnt,prev
                ld      bc,32-prev-(cnt-1)
                add     hl,bc
                ex      hl,de
                add     hl,bc
                ex      hl,de

                xrow     cnt*2-1
        endm

        macro update_pnt_box _start_,_len_,_row_

                ld      hl,PNT     +_start_
                ld      de,localPNT+_start_
                ld      bc,32-_len_

                dup     _row_
                        xrow    _len_

                        add     hl,bc
                        ex      hl,de
                        add     hl,bc
                        ex      hl,de
                edup
        endm

;dad d  10
;xchg 4
;inx 5
;lxi 10
;mov r 4

        macro   xskip _skip_len_
            ld      bc,_skip_len_       ;10
            add     hl,bc               ;10
            ex      de,hl               ;4
            add     hl,bc               ;10
            ex      de,hl               ;4
                                        ;38
        endm

        macro update_pnt_skip     _x_len_,_skip_len_
            xrow    _x_len_
            xskip   _skip_len_
        endm


;use only one PGT and own charset
font_prepare_title:
        ld      hl,show_char_store_title
        ld      (show_char_store_addr+1),hl
        ld      hl,tch_map0
        ld      (font_table_addr+1),hl
        ld      a,M_SCR2_ALL
        ld      (scr2_pnt_mode),a        
        ret        

;use 3 PGT and own charset
font_prepare_game:
        ld      hl,show_char_store
        ld      (show_char_store_addr+1),hl
        ld      hl,chr_map0
        ld      (font_table_addr+1),hl
        ld      a,M_SCR2_ALL
        ld      (scr2_pnt_mode),a
        ret  


scr2_pnt_mode:
        db      M_SCR2_ALL


scr2_ingame_top:

        mdebug_lut_6c 01110001b

        ld      hl,PNT     +0*32+2
        ld      de,localPNT+0*32+2
        update_pnt_0 (3+6+4+6+1)/2

        ld      hl,PNT     +1*32+2
        ld      de,localPNT+1*32+2
        update_pnt_0 (3+6)/2

        ld      hl,PNT     +1*32+16
        ld      de,localPNT+1*32+16
        update_pnt_0 16/2

        mdebug_lut_6c 01000001b
        ret


;hl - srcpnt
show_pnt:
        di
        ld      a, 6Ch ; 'l'
        ld      (regbase1C+SYSREG), a


        push	hl
        push	de
        push	bc


        ld      a,(scr2_pnt_mode)

        cp      M_SCR2_NOP
        jp      z,show_pnt_exit

        cp      M_SCR2_ALL
        jp      z,scr2_all

        cp      M_SCR2_ROPE
        jp      z,scr2_rope

        cp      M_SCR2_FOUNTAIN
        jp      z,scr2_fountain

        cp      M_SCR2_FIREPLACE
        jp      z,scr2_fireplace

        cp      M_SCR2_KONAMI
        jp      z,scr2_konami

        jp      scr2_top

scr2_konami:

        ld      hl, (_Player1Data_LIFE) ;tmp y pos
        ld      de,  VLINE+(21*32)+10
        ex      de,hl
        call    sbchlde
        push    hl
        ex      de, hl
        pop     hl
        ld      bc,-0300h   ;pnt->localPNT
        add     hl,bc

        ex      de,hl


        ld  b,4
s2_konami_row:
        ld  c,12
s2_konami_line:
        ld      a,(de)
        cp      (hl)
        ;ld      a,034h
        ;ld      (hl),a
        jp      z,$+6
        call    show_char_store_title
        inc     hl
        inc     de

        dec     c
        jp      nz,s2_konami_line

        push    bc
        ld      bc,32-12
        add     hl,bc
        ex      de,hl
        add     hl,bc
        ex      de,hl
        pop     bc

        dec     b
        jp      nz,s2_konami_row

        jp      show_pnt_exit    


scr2_top:
        call    scr2_ingame_top
        jp      show_pnt_exit    


scr2_fireplace:
        call    scr2_ingame_top

        update_pnt_box (16*32)+26, 2,2        
        update_pnt_box (16*32)+ 4, 2,2        
        jp      show_pnt_exit         

scr2_fountain:
        call    scr2_ingame_top

        update_pnt_box (10*32)+ 8,3,6        
        update_pnt_box (10*32)+12,3,6        
        update_pnt_box (10*32)+17,3,6        
        update_pnt_box (10*32)+21,3,6        

        jp      show_pnt_exit         

scr2_rope:

        call    scr2_ingame_top

        ld      hl,PNT     +7*32+9
        ld      de,localPNT+7*32+9

;         0         1         2         3        
;         01234567890123456789012345678901    
;         12345678     12345678    1234567
;["07:", "_________XXX_________XXX________"] 3
;["08:", "________XXXXX_______XXXXX_______"] 5
;["09:", "_______XXXXXXX_____XXXXXXX______"] 7
;["10:", "______XXXXXXXXX___XXXXXXXXX_____"] 9
;["11:", "_____XXXXXXXXXXX_XXXXXXXXXXX____"] 11
;["12:", "______XXXXXXXXX___XXXXXXXXX_____"] 9
;["13:", "_______XX_X_XX_____XX_X_XX______"] 7

        update_pnt_skip     3,9
        update_pnt_skip     3,8+8

        update_pnt_skip     5,7
        update_pnt_skip     5,7+7

        update_pnt_skip     7,5
        update_pnt_skip     7,6+6

        update_pnt_skip     9,3
        update_pnt_skip     9,5+5

        update_pnt_skip     11,1
        update_pnt_skip     11,4+4+2

        update_pnt_skip     9,3
        update_pnt_skip     9,5+5+2

        update_pnt_skip     7,5
        update_pnt_skip     7,0

        jp      show_pnt_exit

;scr2_all (show all screen)
scr2_all:


        ld  hl,PNT+32*24-1
        ld	de,localPNT+32*24-1
        ld	bc,0300h

shp_loop:

        ld	a,(de)
        cp 	(hl)

        jp  z,shp_skip
show_char_store_addr:
;        call    nz,show_char_store
        call    show_char_store
shp_skip:

        dec	e
        dec	l
        dec c
        jp  nz,shp_loop
        dec	d
        dec h
        dec b
        jp	nz,shp_loop

show_pnt_exit:

        mdebug_lut_6c 01110001b


        pop	bc
        pop	de
        pop	hl

        ld      a, 1Ch
        ld      (regbase6C+SYSREG), a
;        ei
        ret

;a - char
;de - pnt addr
;config should be regbase6C
show_char_store_title:          ;use only one pgt table
;        di
;        ld      a, 6Ch ; 'l'
;        ld      (regbase1C+SYSREG), a

        ld      a,(hl)
        ld      (de),a
;show_char:

        push    bc
        push    hl
        push    de

        ld      b,0     ;save pnt 1/3
        jp      show_char_interal


;a - char
;de - pnt addr
;config should be regbase6C
show_char_store:               ;use 3 pgt table
;        di
;        ld      a, 6Ch ; 'l'
;        ld      (regbase1C+SYSREG), a

        ld      a,(hl)
	ld	(de),a
;show_char:
show_char_no_store:

	push	bc
	push	hl
	push	de

	ld	b,d	;save pnt 1/3

show_char_interal:
	ex	de,hl
	add	hl,hl
	ld	de,PNT2GZU
	add	hl,de	;gzu addr in
        ld      c,(hl)
        inc     hl
        ld      h,(hl)
        ld      l,c

        ld      (gzu_addr0+1),hl

	ld	l,a
	ld	h,b      ;b 0..2 (get required chargen)
	add	hl,hl
font_table_addr:        
	ld	de,chr_map0
	add	hl,de   ;hl char ptr
        ld      e,(hl)
        inc     hl
        ld      d,(hl)

;        ex      de,hl   ;hl scr addr, de char bitmap
;

        ld      hl,0
        add     hl,sp
        ld      (show_chr_sp+1),hl
        ex      hl,de
        ld      sp,hl

;clear
        ld      a, _WL01_|_LAYER_MODE_W|0
        ld      (regbase6C+NCREG), a

        ld      bc,64
        ld      a,0ffh
        
gzu_addr0:
        ld      hl,0
        ld      (gzu_addr1+1),hl

        dup     8
                ld      (hl), a
                add     hl, bc
        edup

;        pop hl
;first plane

;        ld      a,(de)
        pop     de
        ld      a,e
        or      a
        jp      z,show_char_exit

gzu_addr1:
        ld      hl,0000
        ld      (gzu_addr2+1),hl

        ld      (regbase6C+NCREG), a

        ld      (hl), d
        add     hl, bc

        pop     de
        ld      (hl), e
        add     hl, bc
        ld      (hl), d
        add     hl, bc

        pop     de
        ld      (hl), e
        add     hl, bc
        ld      (hl), d
        add     hl, bc

        pop     de
        ld      (hl), e
        add     hl, bc
        ld      (hl), d
        add     hl, bc

        pop     de
        ld      (hl), e

;second plane


        ld      a,d
        or      a
        jp      z,show_char_exit

        ld      (regbase6C+NCREG), a

gzu_addr2:
        ld      hl,0000

        pop     de
        ld      (hl), e
        add     hl, bc
        ld      (hl), d
        add     hl, bc

        pop     de
        ld      (hl), e
        add     hl, bc
        ld      (hl), d
        add     hl, bc

        pop     de
        ld      (hl), e
        add     hl, bc
        ld      (hl), d
        add     hl, bc

        pop     de
        ld      (hl), e
        add     hl, bc
        ld      (hl), d
        add     hl, bc


show_char_exit:

show_chr_sp:        
        ld      sp,0

	pop	de
	pop	hl
	pop	bc

;        ld      a, 1Ch
;        ld      (regbase6C+SYSREG), a
;        ei

        ret

;clear one character on screen
x_chr_clear:

        di        
        ld      a, 6Ch
        ld      (regbase1C+SYSREG), a

        push    bc
        push    hl
        push    de

        ex      de,hl
        ld      a,-3
        add     a,h
        ld      h,a

        xor     a
        ld      (hl),a      

        add     hl,hl
        ld      de,PNT2GZU
        add     hl,de   ;gzu addr in
        ld      c,(hl)
        inc     hl
        ld      h,(hl)
        ld      l,c

;clear
        ld      a, _WL01_|_LAYER_MODE_W|0
        ld      (regbase6C+NCREG), a

        ld      bc,64
        ld      a,0ffh

        dup     8
                ld      (hl), a
                add     hl, bc
        edup

        pop de
        pop hl
        pop bc
        ld      a, 1Ch
        ld      (regbase6C+SYSREG), a
        ei        
        ret




cls_pnt:
        ld      a,0
        ld      hl,PNT
        ld      de,PNT+1
        ld      (hl),a
        ld      bc,32*24-1
        jp    _LDIR_


init_pnt:

;init pnt2gzu table
;pacman based
	ld	hl, PNT2GZU
	ld	de, GZU_BASE
	ld	bc, 8*64-32
	ld	a, 24

iniColumnLoop:
	push	af
	ld	a, 32

iniRowLoop:
	ld	(hl), e
	inc	hl
	ld	(hl), d
	inc	hl
	inc	de
	dec	a
	jp	nz, iniRowLoop
	ex	de, hl
	add	hl, bc
	ex	de, hl
	pop	af
	dec	a
	jp	nz, iniColumnLoop

        ld      a,0aah
        ld      hl,localPNT
        ld      de,localPNT+1
        ld      (hl),a
        ld      bc,32*24-1
        call    _LDIR_

        jp      cls_pnt
	;ret

