require 'rubygems'
require 'RMagick'
require 'ap'

$colors=[

  #  R G B
  "#000000",
  "#101010",
  "Green",        
  "LightGreen",
  "Blue",
  "LightBlue",
  "Brown",
  "Cyan",
  "Red",          #MediumRed
  "Orange",       #"LightRed",
  "Yellow",       #DarkYellow
  "Pink",         #"LightYellow",
  "DarkGreen",
  "Magenta",
  "LightGray",
  "White",


  # #  R G B
  # "#000000",
  # "#101010",
  # "Green",        #"MediumGreen",
  # "LightGreen",
  # "RoyalBlue",#"DarkBlue",
  # "LightBlue",
  # "DarkRed",
  # "Cyan",
  # "Red",          #MediumRed
  # "Tomato",       #"LightRed",
  # "Yellow",       #DarkYellow
  # "Pink",         #"LightYellow",
  # "DarkGreen",
  # "Magenta",
  # "Gray",
  # "White",

  # "#000000",
  # "#000080",
  # "#008000",
  # "#008080",
  # "#800000",
  # "#800080",
  # "#808000",
  # "#808080",
  # "#101010",
  # "#0000ff",
  # "#00ff00",
  # "#00ffff",
  # "#ff0000",
  # "#ff00ff",
  # "#ffff00",
  # "#ffffff",
]

$transparent_color="#000000"

def draw_line(gc,string,xx,yy,c1,c2)
  x=xx#+5
  y=yy
  string.each_char do |cc|
    fcolor=nil
    if cc == '1'
        fcolor=c1#$colors[c1]
    else
        fcolor=c2#$colors[c2]
    end
    if fcolor != $transparent_color
      gc.fill(fcolor)
      gc.point(x,y)
    end
    # gc.point(x,y) if cc == '1'
    x+=1
  end
end

def display_sprites(matrix16,xx00,yy00,show_number,gc)
  0.upto(63) do |id|
    xx= xx00 + id*(24+1)
    yy= yy00 # + y*(16+1+15)

    if show_number
      gc.fill('black')
      gc.text(xx,yy-2,"%02x" % (id*4) )
    end

    0.upto(15) do |y|
      line=matrix16[id][y]
      #p [:line,id,y,line]
      draw_line(gc,line,xx,yy+y,"red","LightGray")
    end
  end
end  

def get8x8(id,sprite)
    matrix=[]
    0.upto(7) { |y| 
      value = sprite[id*8+y]
      row = "%08b" % value
      matrix[y]=row
    }
    matrix
end

def extract_sprites(sprite)
  m16=[]
  0.upto(63) do |id|
    mlu=get8x8((id*4)+0,sprite)
    mld=get8x8((id*4)+1,sprite)
    mru=get8x8((id*4)+2,sprite)
    mrd=get8x8((id*4)+3,sprite)
    m16[id]=[]
    0.upto(7) do |y|
      m16[id][y+0]=mlu[y]+mru[y]+"00000000"
      m16[id][y+8]=mld[y]+mrd[y]+"00000000"
    end
  end
  #ap m16
  m16
end

def rotate(matrix16,shift)
  mret=[]
  0.upto(63) do |id|
    mret[id]=[]
    0.upto(15) do |y|
      mret[id][y]=(("0"*shift)+matrix16[id][y])[0..23]
    end
  end
  mret
end

def xhex(v)
  x=v.to_i(2)
  s=" "
  s="0" if x>=0xa0
  "%s%02xh" % [s,x]
end

def spr2db(spr,label,skip_flag)
  ret=[]
  ret << "#{label}:"
  unless skip_flag
    spr.each do |ln|
      #z0=ln.scan(/......../).map{|v| xhex(v) }.join(",")
      z0=ln.scan(/......../).map{|v| "#{v}b" }.join(",")
      ret << "\tdb\t#{z0}"
    end
  end
  ret << ""
  ret.join("\n")
end

def dump1sprite(matrix,id,skip_flag)
  idhex="%02X" % (id*4)
  str=";#{"-"*32}sprite #{idhex}\n"
  0.upto(7) do |sprid|
    skip_flag=true if (id == 0xfc/4) and (sprid>=1)
    #fish
    skip_flag=true if (id == 0xb8/4) and (sprid>=1)
    skip_flag=true if (id == 0xbc/4) and (sprid>=1)
    skip_flag=true if (id == 0xc0/4) and (sprid>=1)
    #faces
    skip_flag=true if (id == 0xec/4) and (sprid>=1)
    skip_flag=true if (id == 0xf0/4) and (sprid>=1)
    skip_flag=true if (id == 0xf4/4) and (sprid>=1)
    skip_flag=true if (id == 0xf8/4) and (sprid>=1)
 

    label="spr_%s_%02d" % [idhex,sprid]
    str+=spr2db(matrix[sprid][id],label,skip_flag)
  end
  str
end

def dump_sprites(matrix,skip_sprite)
  str_dw=""

  str=""

  0.upto(63) do |id|
    str_dw+="\tdw\t"
    a=[]
    0.upto(7) do |i07|
      a << ("spr_%02X_%02d" % [id*4,i07])
    end
    str_dw+=a.join(", ")
    str_dw+="\n"

    str+=dump1sprite(matrix,id,skip_sprite.include?(id*4)) 
  end
  str_dw+="\n"
  str_dw+str
end


def sprite_merge(matrix16,spr_1,spr_2)
  a=matrix16[spr_1/4]
  b=matrix16[spr_2/4]
  c=[]
  0.upto(15) do |y|
      c[y]="%024b" % (a[y].to_i(2) ^ b[y].to_i(2))
  end
  #ap [:merge,a,b,c]
  c
end

def scr2(srcname,preffix)
  dstname=srcname.sub(".bin",".png")
  dst_txt=srcname.sub(".bin",".txt")
  puts [dstname]

  imgl = Magick::ImageList.new
  #imgl.new_image(800, 800)
  imgl.new_image(64*(24+1) + 20 , 30+(16+1)*9 )
  gc = Magick::Draw.new
  gc.stroke_antialias(true)
  gc.text_antialias(false)
  gc.font_weight(Magick::NormalWeight)
  gc.font_style(Magick::NormalStyle)
  gc.font_stretch(Magick::UltraCondensedStretch)
  #gc.font_family('courier')
  gc.pointsize(12)

  gc.stroke('Black')
  gc.opacity(1)

  bin=File.open(srcname,"rb").read

  sprite=bin[0x1800..0x1fff].split(//).map{|v| v.ord}
  spratr=bin[0x3B00..0x3B7f].split(//).map{|v| v.ord}

  matrix_spr=[]

  matrix16=extract_sprites(sprite)

  matrix16[0x00/4]=[
        "000000000000000000000000",
        "000000011110010000000000",
        "000011111111111000000000",
        "000111111111111000000000",
        "001111100000000000000000",
        "011111100000000000000000",
        "111111100000000000000000",
        "111111000000000000000000",
        "111110000000000000000000",
        "111100000000000000000000",
        "111100000000000000000000",
        "111110000000000000000000",
        "001111000000000000000000",
        "000111100000000000000000",
        "000011100000000000000000",
        "000000000000000000000000"
  ]
  matrix16[0x5c/4]=[
        "000000000000000000000000",
        "001001111000000000000000",
        "111111111111000000000000",
        "111111111111100000000000",
        "000000000111110000000000",
        "000000000111111000000000",
        "000000000111111100000000",
        "000000000011111100000000",
        "000000000001111100000000",
        "000000000000111100000000",
        "000000000000111100000000",
        "000000000001111100000000",
        "000000000011110000000000",
        "000000000111100000000000",
        "000000000111000000000000",
        "000000000000000000000000"
    ]
  matrix16[0x3c/4]=[
        "011000000000000000000000",
        "011000000000000000000000",
        "011000000000000000000000",
        "001000000000000000000000",
        "001000000000000000000000",
        "011000000000000000000000",
        "011000000000000000000000",
        "011000000000000000000000",
        "011000000000000000000000",
        "011000000000000000000000",
        "011100000000000000000000",
        "011111000000110000000000",
        "011111100001110000000000",
        "001111110011110000000000",
        "001111111111100000000000",
        "000111111111000000000000"
    ]
  matrix16[0x98/4]=[
        "000000000000011000000000",
        "000000000000011000000000",
        "000000000000011000000000",
        "000000000000010000000000",
        "000000000000010000000000",
        "000000000000011000000000",
        "000000000000011000000000",
        "000000000000011000000000",
        "000000000000011000000000",
        "000000000000011000000000",
        "000000000000111000000000",
        "001100000011111000000000",
        "001110000111111000000000",
        "001111001111110000000000",
        "000111111111110000000000",
        "000011111111100000000000"
    ]

  #black line between body and leg
  matrix16[0x10/4][7]="000000000000000000000000"
  matrix16[0x18/4][7]="000000000000000000000000"
  matrix16[0x20/4][7]="000000000000000000000000"
  matrix16[0x28/4][7]="000000000000000000000000"
  matrix16[0x30/4][7]="000000000000000000000000"

  matrix16[0x34/4][6]="000000000000000000000000"

  matrix16[0x6c/4][7]="000000000000000000000000"
  matrix16[0x74/4][7]="000000000000000000000000"
  matrix16[0x7c/4][7]="000000000000000000000000"
  matrix16[0x84/4][7]="000000000000000000000000"
  matrix16[0x8c/4][7]="000000000000000000000000"

  matrix16[0x90/4][6]="000000000000000000000000"
#  ap matrix16[0x0c/4]
#  ap matrix16[0x30/4]

  #head
  matrix16[0x04/4]=sprite_merge(matrix16,0x04,0x00)
  matrix16[0x08/4]=sprite_merge(matrix16,0x08,0x00)
  #head
  matrix16[0x60/4]=sprite_merge(matrix16,0x60,0x5c)
  matrix16[0x64/4]=sprite_merge(matrix16,0x64,0x5c)

  #body right
  [0x0c,0x14,0x1c,0x24,0x2c,0x34].each { |id| matrix16[id/4]=sprite_merge(matrix16,id,id+4)}
  #body left
  [0x68,0x70,0x78,0x80,0x88,0x90].each { |id| matrix16[id/4]=sprite_merge(matrix16,id,id+4)}

  matrix16[0x44/4]=sprite_merge(matrix16,0x3c,0x44)
  matrix16[0x48/4]=sprite_merge(matrix16,0x4c,0x48)
  matrix16[0x50/4]=sprite_merge(matrix16,0x54,0x50)

  matrix16[0xa0/4]=sprite_merge(matrix16,0x98,0xa0)
  matrix16[0xa4/4]=sprite_merge(matrix16,0xa8,0xa4)
  matrix16[0xac/4]=sprite_merge(matrix16,0xb0,0xac)

  skip_sprite=[
    [0x00],
    [0x5c],
    [0x68+4,0x70+4,0x78+4,0x80+4,0x88+4,0x90+4],
    [0x0c+4,0x14+4,0x1c+4,0x24+4,0x2c+4,0x34+4],
    [0x3c,0x4c,0x54],
    [0x98,0xa8,0xb0],
  ].flatten

  matrix_spr << matrix16

  #show_sprites(sprite,10,10,16,gc)
  display_sprites(matrix16,5,15,true,gc)

  1.upto(7) do |x|
    m2=rotate(matrix16,x)
    display_sprites(m2,5,15+(16+1)*x,false,gc)
    matrix_spr << m2
  end

  puts dump_sprites(matrix_spr,skip_sprite)

  gc.stroke('Green')
  gc.opacity(0.2)

  yy=17*8+15
  0.upto(63) { |id|
    xx= 5 + id*(24+1) 
    gc.line( xx+7,15, xx+7,yy) 
    gc.line(xx+15,15,xx+15,yy) 
  }

  gc.draw(imgl)
  imgl.border!(1,1, "LightCyan2")
  imgl.write(preffix+"g_"+dstname)
end



ff=["ss00"]
ff.each{|v| scr2("#{v}.bin","y")}


puts
puts
