require 'rubygems'
require 'RMagick'

$colors=[

  #  R G B
  "#000000",
  "#101010",
  "Green",        
  "LightGreen",
  "Blue",
  "LightBlue",
  "Brown",
  "Cyan",
  "Red",          #MediumRed
  "Orange",       #"LightRed",
  "Yellow",       #DarkYellow
  "Pink",         #"LightYellow",
  "DarkGreen",
  "Magenta",
  "LightGray",
  "White",


  # #  R G B
  # "#000000",
  # "#101010",
  # "Green",        #"MediumGreen",
  # "LightGreen",
  # "RoyalBlue",#"DarkBlue",
  # "LightBlue",
  # "DarkRed",
  # "Cyan",
  # "Red",          #MediumRed
  # "Tomato",       #"LightRed",
  # "Yellow",       #DarkYellow
  # "Pink",         #"LightYellow",
  # "DarkGreen",
  # "Magenta",
  # "Gray",
  # "White",

  # "#000000",
  # "#000080",
  # "#008000",
  # "#008080",
  # "#800000",
  # "#800080",
  # "#808000",
  # "#808080",
  # "#101010",
  # "#0000ff",
  # "#00ff00",
  # "#00ffff",
  # "#ff0000",
  # "#ff00ff",
  # "#ffff00",
  # "#ffffff",
]

$transparent_color="#000000"

def draw_line(gc,string,xx,yy,c1,c2)
  x=xx#+5
  y=yy
  string.each_char do |cc|
    fcolor=nil
    if cc == '1'
        fcolor=$colors[c1]
    else
        fcolor=$colors[c2]
    end
    if fcolor != $transparent_color
      gc.fill(fcolor)
      gc.point(x,y)
    end
    # gc.point(x,y) if cc == '1'
    x+=1
  end
end

def show_char(id,pgt,cpgt,xx,yy,gc)
    #chr=pgt[(id*8)..((id+1)*8-1)]
    0.upto(7) { |y| 
      #value = chr[y]
      colors = 0x8e
      colors = cpgt[id*8+y] unless cpgt == nil

      c1=(colors >> 4) & 0x0f
      c2=(colors >> 0) & 0x0f

      value = pgt[id*8+y]
      row = "%08b" % value
      draw_line(gc,row,xx,yy+y,c1,c2)
    }
end


def show_pnt(pnt,pgt,cpgt,xx00,yy00,gc)

  pgt1=pgt[0x0000..0x07ff]
  pgt2=pgt[0x0800..0x1000]
  pgt3=pgt[0x1000..0x17ff]

  cpgt1=cpgt[0x0000..0x07ff]
  cpgt2=cpgt[0x0800..0x1000]
  cpgt3=cpgt[0x1000..0x17ff]

  0.upto(23) do |y|
    0.upto(31) do |x|

      id=pnt[y*32+x]

      xx=xx00+x*8
      yy=yy00+y*8

      pgt,cpgt=pgt1,cpgt1
      pgt,cpgt=pgt2,cpgt2 if y>=8
      pgt,cpgt=pgt3,cpgt3 if y>=16

      show_char(id,pgt,cpgt,xx,yy,gc)
    end
  end
end

def pnt2txt(pnt)
  txt=Array.new()
  0.upto(23) do |y|
    txt[y]=""
    0.upto(31) do |x|

      id=pnt[y*32+x]
      txt[y]+="%02x" % id
    end
  end
  txt
end

def show1pgt(pgt,cpgt,xx00,yy00,gc)

  0.upto(15) do |y|
    0.upto(15) do |x|

      id=y*16+x
      xx= xx00 + x*(8+1)
      yy= yy00 + y*(8+1)

      show_char(id,pgt,cpgt,xx,yy,gc)
    end
  end
end


def show_pgt(pgt,cpgt,x,y,gc)
  pgt1=pgt[0x0000..0x07ff]
  pgt2=pgt[0x0800..0x1000]
  pgt3=pgt[0x1000..0x17ff]

  cpgt1=cpgt[0x0000..0x07ff]
  cpgt2=cpgt[0x0800..0x1000]
  cpgt3=cpgt[0x1000..0x17ff]


      # pgt,cpgt=pgt1,cpgt1
      # pgt,cpgt=pgt2,cpgt2 if y>=8
      # pgt,cpgt=pgt3,cpgt3 if y>=16
  a=$transparent_color
  $transparent_color=nil
  show1pgt(pgt1,cpgt1,x,y+150*0,gc)
  show1pgt(pgt2,cpgt2,x,y+150*1,gc)
  show1pgt(pgt3,cpgt3,x,y+150*2,gc)
  $transparent_color=a
end

def sprite16(id,pgt,cpgt,xx,yy,gc)
  show_char(id+0,pgt,cpgt,xx+0,yy+0,gc)
  show_char(id+1,pgt,cpgt,xx+0,yy+8,gc)
  show_char(id+2,pgt,cpgt,xx+8,yy+0,gc)
  show_char(id+3,pgt,cpgt,xx+8,yy+8,gc)
end

def show_sprite_16(pgt,cpgt,xx00,yy00,gc)

  id=0
  0.upto(7) do |y|
    0.upto(7) do |x|
      xx= xx00 + x*(16+1)
      yy= yy00 + y*(16+1+10)

      gc.fill('black')
      gc.text(xx,yy-0,"%02x" % id)
      sprite16(id,pgt,cpgt,xx,yy,gc)
      id+=4
    end
  end
end  

def show_sprites(pgt,x,y,mode,gc)
  if mode == 8
    show1pgt(pgt,nil,x,y,gc)
  elsif mode == 16
    show_sprite_16(pgt,nil,x,y,gc)
  else
    raise "invalid mode"
  end
end

def sprite16_on_screen(pgt,sprattr,xx00,yy00,gc)

  0.upto(31) do |nn|
  # nn=14
  # begin
    y,x,id,att=sprattr[(4*nn)..(4*nn+4)]
    color= (att&0xf) << 4
    #color= (8) << 4
    bits=att>>6
    # p [nn,x,y,"%02x" % id,color>>4,"%02x" % att]

#    color=0x80

    cpgt=Array.new(256*8) { nil }
    cpgt[(id*8)..((id+4)*8)]=[color]*32

    sprite16(id,pgt,cpgt,xx00+x,yy00+y,gc) if y<192
  end
end



def scr2(srcname,preffix)
  dstname=srcname.sub(".bin",".png")
  dst_txt=srcname.sub(".bin",".txt")
  p [dstname]

  imgl = Magick::ImageList.new
  #imgl.new_image(800, 800)
  imgl.new_image(320, 215+150*3)
  gc = Magick::Draw.new
  gc.stroke_antialias(true)
  gc.text_antialias(false)
  gc.font_weight(Magick::NormalWeight)
  gc.font_style(Magick::NormalStyle)
  gc.font_stretch(Magick::UltraCondensedStretch)
  #gc.font_family('courier')
  gc.pointsize(12)


  gc.stroke('Black')
  gc.opacity(1)
  gc.rectangle(5,5, 5+(32*8)-1,5+(24*8)-1)

  gc.stroke('Green')
  gc.opacity(0.2)

  0.upto(32-1) { |x| gc.line(5+8*x,0,5+8*x,5+8*24+5) }
  0.upto(24) { |y| gc.line(0    ,5+8*y,5+8*32+5,5+8*y) }


  gc.stroke('Black')
  gc.opacity(1)

  bin=File.open(srcname,"rb").read

  cpgt  =bin[0x0000..0x17ff].split(//).map{|v| v.ord}
  pgt   =bin[0x2000..0x37ff].split(//).map{|v| v.ord}
  pnt   =bin[0x3800..0x3aff].split(//).map{|v| v.ord}

  sprite=bin[0x1800..0x1fff].split(//).map{|v| v.ord}
  spratr=bin[0x3B00..0x3B7f].split(//).map{|v| v.ord}

  show_pnt(pnt,pgt,cpgt,5,5,gc)
  show_pgt(pgt,cpgt,5,215,gc)

  show_sprites(sprite,16*9+20,215,8,gc)
  show_sprites(sprite,16*9+20,215+16*9+10,16,gc)

  sprite16_on_screen(sprite,spratr,5,5,gc)


  gc.stroke('Red')
  gc.opacity(0.2)
  gc.line(0,5+8* 0,320,5+8* 0)
  gc.line(0,5+8* 8,320,5+8* 8)
  gc.line(0,5+8*16,320,5+8*16)


  gc.draw(imgl)
  imgl.border!(1,1, "LightCyan2")
  imgl.write(preffix+"g_"+dstname)

  txt=pnt2txt(pnt)
  File.open(preffix+"t_"+dst_txt, "w") { |file| file.puts txt  }
end

# scr2("Konami1.bin","y")
# scr2("Konami2.bin","y")

# scr2("s0-fade.bin","y")
# scr2("s0-konami.bin","y")
# scr2("s0-menu.bin","y")

# ff=[0,1,2,3,6,7,9,10,12,13,99]
# ff.each{|v| scr2("ss#{"%02d"%v}.bin","y")}

# ff=[0,10,20,30,40,50,60,70,80,90]
# ff.each{|v| scr2("F#{"%02d"%v}.bin","y")}

ff=["ss00"]
ff.each{|v| scr2("#{v}.bin","y")}


